diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index 3ad526b0c..02e97ce0c 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -100,7 +100,7 @@ public class TexturePackList
 			File[] filesInDir = texturePackDir.listFiles();
 			
 			if(filesInDir != null) {
-				if (Global.BUILD_CHANNEL.isUnstableBuild()) { // Load project resources as an available texture pack
+				if (mc.gameSettings.enableDevResourceLoading.value) { // Load project resources as an available texture pack
 					File[] tempList = new File[filesInDir.length + 1];
 					for (int i = 0; i < tempList.length; i++) {
 						if (i < tempList.length - 1){
diff --git a/src/main/java/net/minecraft/client/sound/SoundEngine.java b/src/main/java/net/minecraft/client/sound/SoundEngine.java
index 7278b5158..7d107b2a6 100644
--- a/src/main/java/net/minecraft/client/sound/SoundEngine.java
+++ b/src/main/java/net/minecraft/client/sound/SoundEngine.java
@@ -6,6 +6,7 @@ import java.util.Random;
 
 import net.betterthanadventure.sound.LibraryLWJGL3OpenAL;
 import net.minecraft.client.Minecraft;
+import net.minecraft.core.Global;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
@@ -145,10 +146,12 @@ public class SoundEngine
         if (!loaded && (gamesettings != null && SoundCategoryHelper.isAnyEnabled(gamesettings))) {
             loadLibrary();
         }
-		loadDevAudio("devResources/sound", soundRepo);
-		loadDevAudio("devResources/streaming", streamingRepo);
-		loadDevAudio("devResources/music", musicRepo);
-		loadDevAudio("devResources/cavemusic", caveRepo);
+		if (gamesettings != null && gamesettings.enableDevResourceLoading.value) {
+			loadDevAudio("devResources/sound", soundRepo);
+			loadDevAudio("devResources/streaming", streamingRepo);
+			loadDevAudio("devResources/music", musicRepo);
+			loadDevAudio("devResources/cavemusic", caveRepo);
+		}
         loadModAudio("minecraft-bta/resources/mod/sound", soundRepo);
         loadModAudio("minecraft-bta/resources/mod/streaming", streamingRepo);
         loadModAudio("minecraft-bta/resources/mod/music", musicRepo);
diff --git a/src/main/java/net/minecraft/core/block/Blocks.java b/src/main/java/net/minecraft/core/block/Blocks.java
index 73ec8fa22..2c7adf37e 100644
--- a/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/src/main/java/net/minecraft/core/block/Blocks.java
@@ -133,6 +133,7 @@ public final class Blocks {
 
     public static Block GLASS;
     public static Block GLASS_TINTED;
+    public static Block GLASS_STEEL;
 
     public static Block GRASS;
     public static Block GRASS_RETRO;
@@ -308,6 +309,7 @@ public final class Blocks {
     public static Block TRAPDOOR_IRON;
     public static Block TRAPDOOR_GLASS;
     public static Block TRAPDOOR_PLANKS_PAINTED;
+    public static Block TRAPDOOR_STEEL;
 
     public static Block TNT;
 
@@ -319,6 +321,8 @@ public final class Blocks {
     public static Block DOOR_PLANKS_PAINTED_TOP;
     public static Block DOOR_GLASS_BOTTOM;
     public static Block DOOR_GLASS_TOP;
+    public static Block DOOR_STEEL_BOTTOM;
+    public static Block DOOR_STEEL_TOP;
 
     public static Block MESH;
     public static Block MESH_GOLD;
@@ -654,6 +658,7 @@ public final class Blocks {
 
         GLASS = new GlassBlock("glass", "minecraft:block/glass", 190, Material.glass).withSound(BlockSounds.GLASS).withHardness(0.3F).withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.EXTENDS_MOTION_SENSOR_RANGE);
         GLASS_TINTED = new TintedGlassBlock("glass.tinted", "minecraft:block/glass_tinted", 191).withSound(BlockSounds.GLASS).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange().withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        GLASS_STEEL = new TransparentBlock("glass.steel", "minecraft:block/glass_steel", 192, Material.glass).withSound(BlockSounds.GLASS).withHardness(0.3F).withBlastResistance(2000F).withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.EXTENDS_MOTION_SENSOR_RANGE);
 
         GRASS = new GrassBlock("grass", "minecraft:block/grass", 200, Material.grass).withSound(BlockSounds.GRASS).withHardness(0.6F)
             .withTags(BlockTags.MINEABLE_BY_SHOVEL, BlockTags.GROWS_FLOWERS, BlockTags.GROWS_SUGAR_CANE, BlockTags.PASSIVE_MOBS_SPAWN, BlockTags.FIREFLIES_CAN_SPAWN, BlockTags.GROWS_TREES, BlockTags.CAVES_CUT_THROUGH, BlockTags.CAVE_GEN_REPLACES_SURFACE);
@@ -968,16 +973,18 @@ public final class Blocks {
         TRAPDOOR_PLANKS_PAINTED = new PaintedTrapDoorBlock("trapdoor.planks.oak.painted", "minecraft:block/trapdoor_planks_oak_painted", 573, Material.wood).withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange()
             .setBlockItem((b) -> new PaintedBlockItem(b, true))
             .withTags(BlockTags.MINEABLE_BY_AXE);
+        TRAPDOOR_STEEL = new TrapDoorBlock("trapdoor.steel", "minecraft:block/trapdoor_steel", 574, Material.metal, true).withSound(BlockSounds.METAL).withHardness(5F).withBlastResistance(2000F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.steel)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         TNT = new TNTBlock("tnt", "minecraft:block/tnt", 580).withSound(BlockSounds.GRASS).withHardness(0.0F);
 
-        DOOR_PLANKS_OAK_BOTTOM = new DoorBlock("door.planks.oak.bottom", "minecraft:block/door_planks_oak_bottom", 590, Material.wood, false).withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.DOOR_OAK)
+        DOOR_PLANKS_OAK_BOTTOM = new DoorBlock("door.planks.oak.bottom", "minecraft:block/door_planks_oak_bottom", 590, Material.wood, false, false, () -> Items.DOOR_OAK).withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.DOOR_OAK)
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
-        DOOR_PLANKS_OAK_TOP = new DoorBlock("door.planks.oak.top", "minecraft:block/doors_planks_oak_top", 591, Material.wood, true).withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> DOOR_PLANKS_OAK_BOTTOM)
+        DOOR_PLANKS_OAK_TOP = new DoorBlock("door.planks.oak.top", "minecraft:block/doors_planks_oak_top", 591, Material.wood, true, false, () -> Items.DOOR_OAK).withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> DOOR_PLANKS_OAK_BOTTOM)
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
-        DOOR_IRON_BOTTOM = new DoorBlock("door.iron.bottom", "minecraft:block/door_iron_bottom", 592, Material.metal, false).withSound(BlockSounds.METAL).withHardness(5F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.iron).setStatParent(() -> Items.DOOR_IRON)
+        DOOR_IRON_BOTTOM = new DoorBlock("door.iron.bottom", "minecraft:block/door_iron_bottom", 592, Material.metal, false, true, () -> Items.DOOR_IRON).withSound(BlockSounds.METAL).withHardness(5F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.iron).setStatParent(() -> Items.DOOR_IRON)
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
-        DOOR_IRON_TOP = new DoorBlock("door.iron.top", "minecraft:block/door_iron_top", 593, Material.metal, true).withSound(BlockSounds.METAL).withHardness(5F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.iron).setStatParent(() -> DOOR_IRON_BOTTOM)
+        DOOR_IRON_TOP = new DoorBlock("door.iron.top", "minecraft:block/door_iron_top", 593, Material.metal, true, true, () -> Items.DOOR_IRON).withSound(BlockSounds.METAL).withHardness(5F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.iron).setStatParent(() -> DOOR_IRON_BOTTOM)
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
         DOOR_PLANKS_PAINTED_BOTTOM = new DoorPaintedBlock("door.planks.oak.painted.bottom", "minecraft:block/door_planks_oak_painted_bottom", 594, Material.wood, false).withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.DOOR_OAK_PAINTED)
             .setBlockItem((b) -> new PaintedBlockItem(b, true))
@@ -985,9 +992,13 @@ public final class Blocks {
         DOOR_PLANKS_PAINTED_TOP = new DoorPaintedBlock("door.planks.oak.painted.top", "minecraft:block/door_planks_oak_painted_top", 595, Material.wood, true).withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> DOOR_PLANKS_PAINTED_BOTTOM)
             .setBlockItem((b) -> new PaintedBlockItem(b, true))
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
-        DOOR_GLASS_BOTTOM = new GlassDoorBlock("door.glass.bottom", "minecraft:block/door_glass_bottom", 596, Material.glass, false).withSound(BlockSounds.GLASS).withHardness(0.3F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.DOOR_GLASS)
+        DOOR_GLASS_BOTTOM = new DoorBlock("door.glass.bottom", "minecraft:block/door_glass_bottom", 596, Material.glass, false, false, () -> Items.DOOR_GLASS).withSound(BlockSounds.GLASS).withHardness(0.3F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.DOOR_GLASS)
+            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
+        DOOR_GLASS_TOP = new DoorBlock("door.glass.top", "minecraft:block/door_glass_top", 597, Material.glass, true, false, () -> Items.DOOR_GLASS).withSound(BlockSounds.GLASS).withHardness(0.3F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> DOOR_GLASS_BOTTOM)
+            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
+        DOOR_STEEL_BOTTOM = new DoorBlock("door.steel.bottom", "minecraft:block/door_steel_bottom", 598, Material.metal, false, true, () -> Items.DOOR_STEEL).withSound(BlockSounds.METAL).withHardness(5F).withBlastResistance(2000F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.steel).setStatParent(() -> Items.DOOR_STEEL)
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
-        DOOR_GLASS_TOP = new GlassDoorBlock("door.glass.top", "minecraft:block/door_glass_top", 597, Material.glass, true).withSound(BlockSounds.GLASS).withHardness(0.3F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> DOOR_GLASS_BOTTOM)
+        DOOR_STEEL_TOP = new DoorBlock("door.steel.top", "minecraft:block/door_steel_top", 599, Material.metal, true, true, () -> Items.DOOR_STEEL).withSound(BlockSounds.METAL).withHardness(5F).withBlastResistance(2000F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.steel).setStatParent(() -> DOOR_STEEL_BOTTOM)
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
         MESH = new MeshBlock("mesh", "minecraft:block/mesh", 600).withSound(BlockSounds.METAL).withHardness(1.5F)
diff --git a/src/main/java/net/minecraft/core/block/DoorBlock.java b/src/main/java/net/minecraft/core/block/DoorBlock.java
index 46f984580..395f38b30 100644
--- a/src/main/java/net/minecraft/core/block/DoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/DoorBlock.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block;
 
 import java.util.Random;
+import java.util.function.Supplier;
 
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.phys.HitResult;
@@ -16,6 +17,7 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, IBlockAccess, World, 
@@ -25,12 +27,17 @@ import net.minecraft.core.world.WorldSource;
 public class DoorBlock extends Block
 {
 
-	public final boolean isTop; 
+	public final boolean isTop;
+	public final boolean requireTool;
+    @Nullable
+    public final Supplier<Item> droppedItem;
 	
-	public DoorBlock(String key, String namespaceId, int id, Material material, boolean isTop)
+	public DoorBlock(String key, String namespaceId, int id, Material material, boolean isTop, boolean requireTool, @Nullable Supplier<Item> droppedItem)
     {
         super(key, namespaceId, id, material);
         this.isTop = isTop;
+        this.requireTool = requireTool;
+        this.droppedItem = droppedItem;
         float f = 0.5F;
         if (isTop)
         {
@@ -238,13 +245,14 @@ public class DoorBlock extends Block
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-        if (blockMaterial == Material.metal && dropCause != EnumDropCause.IMPROPER_TOOL)
+        if (droppedItem == null) return null;
+        if (requireTool && dropCause != EnumDropCause.IMPROPER_TOOL)
         {
-            return new ItemStack[] { new ItemStack(Items.DOOR_IRON) };
+            return new ItemStack[] { new ItemStack(droppedItem.get()) };
         }
-        else if (blockMaterial == Material.wood)
+        else if (!requireTool)
         {
-            return new ItemStack[] { new ItemStack(Items.DOOR_OAK) };
+            return new ItemStack[] { new ItemStack(droppedItem.get()) };
         }
 
         return null;
diff --git a/src/main/java/net/minecraft/core/block/DoorPaintedBlock.java b/src/main/java/net/minecraft/core/block/DoorPaintedBlock.java
index 5f4710ab4..a2daae478 100644
--- a/src/main/java/net/minecraft/core/block/DoorPaintedBlock.java
+++ b/src/main/java/net/minecraft/core/block/DoorPaintedBlock.java
@@ -9,7 +9,7 @@ import net.minecraft.core.world.World;
 
 public class DoorPaintedBlock extends DoorBlock {
     public DoorPaintedBlock(String key, String namespaceId, int id, Material material, boolean isTop) {
-        super(key, namespaceId, id, material, isTop);
+        super(key, namespaceId, id, material, isTop, false, null);
     }
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
diff --git a/src/main/java/net/minecraft/core/block/TransparentBlock.java b/src/main/java/net/minecraft/core/block/TransparentBlock.java
index 85ee513ca..57c3e9d2c 100644
--- a/src/main/java/net/minecraft/core/block/TransparentBlock.java
+++ b/src/main/java/net/minecraft/core/block/TransparentBlock.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 
-public abstract class TransparentBlock extends Block
+public class TransparentBlock extends Block
 {
 
 	public TransparentBlock(String key, String namespaceId, int id, Material material)
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
index 89b8f86c5..6424f12d0 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
@@ -12,6 +12,8 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.HardIllegalArgumentException;
+import net.minecraft.core.util.collection.NamespaceID;
 
 import java.lang.reflect.Type;
 
@@ -36,7 +38,17 @@ public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSe
                 throw new IllegalArgumentException("Failed to find item for key '" + key + "'!\n" + e.getMessage());
             }
         } else {
-            item = Item.itemsList[obj.get("id").getAsInt()];
+            JsonElement e = obj.get("id");
+            try {
+                item = Item.itemsList[e.getAsInt()];
+            } catch (NumberFormatException ignored) { // NumberFormatException thrown if element is not actually convertible to a number
+                try {
+                    item = Item.itemsMap.get(new NamespaceID(e.getAsString()));
+                } catch (HardIllegalArgumentException ex) {
+                    throw new JsonParseException(ex);
+                }
+            }
+
         }
         if(obj.has("amount")){
            stack = new ItemStack(item,obj.get("amount").getAsInt(),obj.get("meta").getAsInt());
@@ -49,7 +61,8 @@ public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSe
     @Override
     public JsonElement serialize(ItemStack src, Type typeOfSrc, JsonSerializationContext context) {
         JsonObject obj = new JsonObject();
-        obj.addProperty("id",src.itemID);
+//        obj.addProperty("id",src.itemID); // Preferring namespace ids over integer ids for readability reasons
+        obj.addProperty("id",src.getItem().namespaceID.toString());
         obj.addProperty("amount",src.stackSize);
         obj.addProperty("meta",src.getMetadata());
         return obj;
diff --git a/src/main/java/net/minecraft/core/entity/FishingBobberEntity.java b/src/main/java/net/minecraft/core/entity/FishingBobberEntity.java
index 34afa481a..8f05a057c 100644
--- a/src/main/java/net/minecraft/core/entity/FishingBobberEntity.java
+++ b/src/main/java/net/minecraft/core/entity/FishingBobberEntity.java
@@ -18,10 +18,10 @@ import java.util.List;
 
 public class FishingBobberEntity extends Entity
 {
+    public static final int ID_BOBBER_BITFIELD = 2;
     private int xTile;
     private int yTile;
     private int zTile;
-    private boolean inGround;
     public Player owner;
     private int ticksInAir;
     private int ticksCatchable;
@@ -79,6 +79,15 @@ public class FishingBobberEntity extends Entity
     @Override
 	protected void defineSynchedData()
     {
+        entityData.define(ID_BOBBER_BITFIELD, (byte)0);
+    }
+
+    public boolean isInGround() {
+        return entityData.getByte(ID_BOBBER_BITFIELD) != 0;
+    }
+
+    public void setInGround(boolean flag) {
+        entityData.set(ID_BOBBER_BITFIELD, flag ? (byte)1 : (byte)0);
     }
 
     @Override
@@ -173,14 +182,14 @@ public class FishingBobberEntity extends Entity
                 }
             }
         }
-        if (inGround) {
+        if (isInGround()) {
             if (world.getBlockId(xTile, yTile, zTile) == Blocks.ROPE.id) {
                 x = xTile + 0.5D;
                 y = yTile + 0.5D;
                 z = zTile + 0.5D;
                 return;
             } else {
-                inGround = false;
+                setInGround(false);
                 xd *= random.nextFloat() * 0.2F;
                 yd *= random.nextFloat() * 0.2F;
                 zd *= random.nextFloat() * 0.2F;
@@ -198,7 +207,7 @@ public class FishingBobberEntity extends Entity
         {
             nextPos = Vec3.getTempVec3(clip.location.x, clip.location.y, clip.location.z);
             if (clip.hitType == HitResult.HitType.TILE && world.getBlockId(clip.x, clip.y, clip.z) == Blocks.ROPE.id) {
-                inGround = true;
+                setInGround(true);
                 xTile = clip.x;
                 yTile = clip.y;
                 zTile = clip.z;
@@ -330,18 +339,10 @@ public class FishingBobberEntity extends Entity
 
     @Override
 	public void addAdditionalSaveData(CompoundTag compoundTag) {
-        compoundTag.putShort("xTile", (short)this.xTile);
-        compoundTag.putShort("yTile", (short)this.yTile);
-        compoundTag.putShort("zTile", (short)this.zTile);
-        compoundTag.putByte("inGround", (byte)(this.inGround ? 1 : 0));
     }
 
     @Override
 	public void readAdditionalSaveData(CompoundTag compoundTag) {
-        this.xTile = compoundTag.getShort("xTile");
-        this.yTile = compoundTag.getShort("yTile");
-        this.zTile = compoundTag.getShort("zTile");
-        this.inGround = (compoundTag.getByte("inGround") == 1);
     }
 
     @Override
@@ -354,7 +355,7 @@ public class FishingBobberEntity extends Entity
     {
         int damage = 0;
 
-        if(inGround)
+        if(isInGround())
         {
             double dx = x - owner.x;
             double dy = y - owner.y;
@@ -400,7 +401,7 @@ public class FishingBobberEntity extends Entity
             owner.addStat(StatList.fishCaughtStat, 1);
             damage = 1;
         }
-        if(inGround)
+        if(isInGround())
         {
             damage = 2;
         }
diff --git a/src/main/java/net/minecraft/core/entity/Mob.java b/src/main/java/net/minecraft/core/entity/Mob.java
index 137609321..f238746cc 100644
--- a/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/src/main/java/net/minecraft/core/entity/Mob.java
@@ -2,6 +2,7 @@ package net.minecraft.core.entity;
 
 import com.b100.utils.StringUtils;
 import com.mojang.nbt.CompoundTag;
+import net.minecraft.client.Minecraft;
 import net.minecraft.core.Global;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.WeightedRandomLootObject;
@@ -762,7 +763,16 @@ public abstract class Mob extends Entity
             yd *= 0.8D;
             zd *= 0.8D;
             yd -= 0.02D;
-            if(horizontalCollision && isFree(xd, ((yd + 0.6D) - y) + d, zd))
+            int blockX = MathHelper.floor(x);
+            int blockY = MathHelper.floor(y - heightOffset);
+            int blockZ = MathHelper.floor(z);
+            Block b = world.getBlock(blockX, blockY, blockZ);
+            float depth = 0.6f;
+            if (b != null) {
+                b.setBlockBoundsBasedOnState(world, blockX, blockY, blockZ);
+                depth = 1 - (float) b.maxY;
+            }
+            if(horizontalCollision && isFree(xd, ((yd + depth + 0.2) - y) + d, zd))
             {
                 yd = 0.3D;
             }
@@ -983,15 +993,15 @@ public abstract class Mob extends Entity
         {
             updateAI();
         }
-        boolean flag = isInWater();
-        boolean flag1 = isInLava();
+        boolean inWater = isInWater();
+        boolean inLava = isInLava();
         if(isJumping)
         {
-            if(flag)
+            if(inWater)
             {
                 yd += 0.04D;
             } else
-            if(flag1)
+            if(inLava)
             {
                 yd += 0.04D;
             } else
@@ -1105,9 +1115,9 @@ public abstract class Mob extends Entity
             yRot += randomYawVelocity;
             xRot = defaultPitch;
         }
-        boolean flag = isInWater();
-        boolean flag1 = isInLava();
-        if(flag || flag1)
+        boolean inWater = isInWater();
+        boolean inLava = isInLava();
+        if(inWater || inLava)
         {
             isJumping = random.nextFloat() < 0.8F;
         }
diff --git a/src/main/java/net/minecraft/core/entity/SpawnListEntry.java b/src/main/java/net/minecraft/core/entity/SpawnListEntry.java
index 0e5744d07..103df3edd 100644
--- a/src/main/java/net/minecraft/core/entity/SpawnListEntry.java
+++ b/src/main/java/net/minecraft/core/entity/SpawnListEntry.java
@@ -4,12 +4,12 @@ package net.minecraft.core.entity;
 public class SpawnListEntry
 {
 
-    public SpawnListEntry(Class<?> clazz, int frequency)
+    public SpawnListEntry(Class<? extends Entity> clazz, int frequency)
     {
         entityClass = clazz;
         spawnFrequency = frequency;
     }
 
-    public Class<?> entityClass;
+    public Class<? extends Entity> entityClass;
     public int spawnFrequency;
 }
diff --git a/src/main/java/net/minecraft/core/item/Items.java b/src/main/java/net/minecraft/core/item/Items.java
index 33d079d8b..fecd54aac 100644
--- a/src/main/java/net/minecraft/core/item/Items.java
+++ b/src/main/java/net/minecraft/core/item/Items.java
@@ -187,6 +187,7 @@ public final class Items {
     public static Item ROPE;
     public static Item FOOD_PUMPKIN_PIE;
     public static Item WAND_MONSTER_SPAWNER;
+    public static Item DOOR_STEEL;
     public static void init(){
         setupItems();
         initStats();
@@ -391,5 +392,6 @@ public final class Items {
         ROPE = new RopeItem("rope", "minecraft:item/rope", 16534, Blocks.ROPE);
         FOOD_PUMPKIN_PIE = (new PlaceableItem("food.pumpkin_pie", "minecraft:item/food_pumpkin_pie", 16535, Blocks.PUMPKIN_PIE)).setMaxStackSize(1);
         WAND_MONSTER_SPAWNER = (new SpawnerWandItem("wand.monster", "minecraft:item/wand_monster", 16536)).setMaxStackSize(1);
+        DOOR_STEEL = (new DoorItem("door.steel", "minecraft:item/door_steel", 16537, Blocks.DOOR_STEEL_BOTTOM, Blocks.DOOR_STEEL_TOP));
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/Commands.java b/src/main/java/net/minecraft/core/net/command/Commands.java
index 3a28ad487..3825ee241 100644
--- a/src/main/java/net/minecraft/core/net/command/Commands.java
+++ b/src/main/java/net/minecraft/core/net/command/Commands.java
@@ -55,6 +55,7 @@ public final class Commands {
 		commands.add(new SpawnParticleCommand());
 		commands.add(new PlaySoundCommand());
 		commands.add(new HarmCommand());
+		commands.add(new MobSpawningCommand());
 	}
 	
 	public static void initServerCommands(MinecraftServer server) {
diff --git a/src/main/java/net/minecraft/core/net/command/commands/MobSpawningCommand.java b/src/main/java/net/minecraft/core/net/command/commands/MobSpawningCommand.java
new file mode 100644
index 000000000..466ecff29
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/MobSpawningCommand.java
@@ -0,0 +1,77 @@
+package net.minecraft.core.net.command.commands;
+
+import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.net.command.Command;
+import net.minecraft.core.net.command.CommandHandler;
+import net.minecraft.core.net.command.CommandSender;
+import net.minecraft.core.world.SpawnerMobs;
+import net.minecraft.core.world.World;
+
+import java.util.Collection;
+import java.util.Locale;
+
+public class MobSpawningCommand extends Command {
+    public MobSpawningCommand() {
+        super("mobspawning");
+    }
+
+    @Override
+    public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
+        if (args.length == 0) return false;
+
+        World world = handler.getWorld(0);
+        SpawnerMobs.SpawnerConfig config = world.spawningConfig;
+        switch (args[0].toLowerCase(Locale.ROOT)) {
+            case "list": // Lists out all mobs and their current spawn state
+            {
+                Collection<String> ids = EntityDispatcher.classToKeyMap.values();
+                for (String s : ids) {
+                    sender.sendMessage(String.format("%s : %s", s, config.canMobSpawn(s)));
+                }
+                sender.sendMessage("Passive Spawning : " + config.canPassiveSpawn(world));
+                sender.sendMessage("Hostile Spawning : " + config.canHostileSpawn(world));
+                return true;
+            }
+            case "set": // Sets the spawning state of a specific mob id
+            {
+                if (args.length != 3) return false;
+                String mobId = args[1];
+                boolean value = Boolean.parseBoolean(args[2].toLowerCase(Locale.ROOT));
+                config.setMobSpawn(mobId, value);
+                sender.sendMessage(String.format("Set '%s' to '%s'", mobId, value));
+                return true;
+            }
+            case "passive": // Special case for setting state of all peaceful mobs
+            {
+                if (args.length != 2) return false;
+                boolean value = Boolean.parseBoolean(args[1].toLowerCase(Locale.ROOT));
+                config.setPassiveSpawning(value);
+                sender.sendMessage(String.format("Passive spawning to '%s'", value));
+                return true;
+            }
+            case "hostile": // Special case for setting state of all hostile mobs
+            {
+                if (args.length != 2) return false;
+                boolean value = Boolean.parseBoolean(args[1].toLowerCase(Locale.ROOT));
+                config.setHostileSpawning(value);
+                sender.sendMessage(String.format("Hostile spawning to '%s'", value));
+                return true;
+            }
+        }
+
+        return false;
+    }
+
+    @Override
+    public boolean opRequired(String[] args) {
+        return true;
+    }
+
+    @Override
+    public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
+        sender.sendMessage("/mobspawning list");
+        sender.sendMessage("/mobspawning set <id> <value>");
+        sender.sendMessage("/mobspawning passive <value>");
+        sender.sendMessage("/mobspawning hostile <value>");
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java b/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
index 63ea1ec02..598bcf8ea 100644
--- a/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
+++ b/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
@@ -3,7 +3,7 @@ package net.minecraft.core.net.entity;
 import net.minecraft.core.net.entity.entries.AnimalNetEntry;
 import net.minecraft.core.net.entity.entries.ArrowNetEntry;
 import net.minecraft.core.net.entity.entries.BoatNetEntry;
-import net.minecraft.core.net.entity.entries.BobberEntry;
+import net.minecraft.core.net.entity.entries.BobberNetEntry;
 import net.minecraft.core.net.entity.entries.CannonballEntry;
 import net.minecraft.core.net.entity.entries.EggNetEntry;
 import net.minecraft.core.net.entity.entries.FallingSandNetEntry;
@@ -146,6 +146,6 @@ public class NetEntityHandler {
         registerNetworkEntry(new FallingSandNetEntry(), 20);
         registerNetworkEntry(new TNTNetEntry(), 21);
 
-        registerNetworkEntry(new BobberEntry(), 30);
+        registerNetworkEntry(new BobberNetEntry(), 30);
     }
 }
